Add `drbdsetup show` parser for DRBD 8.4
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 blockdir = $(pkgpythondir)/block
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/confd \
110         lib/http \
111         lib/hypervisor \
112         lib/block \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bootstrap.py \
263         lib/cli.py \
264         lib/cmdlib.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/ht.py \
271         lib/jqueue.py \
272         lib/jstore.py \
273         lib/locking.py \
274         lib/luxi.py \
275         lib/mcpu.py \
276         lib/netutils.py \
277         lib/objects.py \
278         lib/opcodes.py \
279         lib/outils.py \
280         lib/ovf.py \
281         lib/pathutils.py \
282         lib/qlang.py \
283         lib/query.py \
284         lib/rpc.py \
285         lib/rpc_defs.py \
286         lib/runtime.py \
287         lib/serializer.py \
288         lib/ssconf.py \
289         lib/ssh.py \
290         lib/storage.py \
291         lib/uidpool.py \
292         lib/vcluster.py \
293         lib/network.py \
294         lib/workerpool.py
295
296 client_PYTHON = \
297         lib/client/__init__.py \
298         lib/client/gnt_backup.py \
299         lib/client/gnt_cluster.py \
300         lib/client/gnt_debug.py \
301         lib/client/gnt_group.py \
302         lib/client/gnt_instance.py \
303         lib/client/gnt_job.py \
304         lib/client/gnt_node.py \
305         lib/client/gnt_network.py \
306         lib/client/gnt_os.py \
307         lib/client/gnt_storage.py
308
309 hypervisor_PYTHON = \
310         lib/hypervisor/__init__.py \
311         lib/hypervisor/hv_base.py \
312         lib/hypervisor/hv_chroot.py \
313         lib/hypervisor/hv_fake.py \
314         lib/hypervisor/hv_kvm.py \
315         lib/hypervisor/hv_lxc.py \
316         lib/hypervisor/hv_xen.py
317
318 block_PYTHON = \
319         lib/block/__init__.py \
320         lib/block/bdev.py \
321         lib/block/base.py \
322         lib/block/drbd.py \
323         lib/block/drbd_info.py
324
325 rapi_PYTHON = \
326         lib/rapi/__init__.py \
327         lib/rapi/baserlib.py \
328         lib/rapi/client.py \
329         lib/rapi/client_utils.py \
330         lib/rapi/connector.py \
331         lib/rapi/rlib2.py \
332         lib/rapi/testutils.py
333
334 http_PYTHON = \
335         lib/http/__init__.py \
336         lib/http/auth.py \
337         lib/http/client.py \
338         lib/http/server.py
339
340 confd_PYTHON = \
341         lib/confd/__init__.py \
342         lib/confd/client.py
343
344 masterd_PYTHON = \
345         lib/masterd/__init__.py \
346         lib/masterd/iallocator.py \
347         lib/masterd/instance.py
348
349 impexpd_PYTHON = \
350         lib/impexpd/__init__.py
351
352 watcher_PYTHON = \
353         lib/watcher/__init__.py \
354         lib/watcher/nodemaint.py \
355         lib/watcher/state.py
356
357 server_PYTHON = \
358         lib/server/__init__.py \
359         lib/server/masterd.py \
360         lib/server/noded.py \
361         lib/server/rapi.py
362
363 pytools_PYTHON = \
364         lib/tools/__init__.py \
365         lib/tools/burnin.py \
366         lib/tools/ensure_dirs.py \
367         lib/tools/node_cleanup.py \
368         lib/tools/node_daemon_setup.py \
369         lib/tools/prepare_node_join.py
370
371 utils_PYTHON = \
372         lib/utils/__init__.py \
373         lib/utils/algo.py \
374         lib/utils/filelock.py \
375         lib/utils/hash.py \
376         lib/utils/io.py \
377         lib/utils/log.py \
378         lib/utils/lvm.py \
379         lib/utils/mlock.py \
380         lib/utils/nodesetup.py \
381         lib/utils/process.py \
382         lib/utils/retry.py \
383         lib/utils/storage.py \
384         lib/utils/text.py \
385         lib/utils/wrapper.py \
386         lib/utils/x509.py
387
388 docinput = \
389         doc/conf.py \
390         doc/css/style.css \
391         doc/admin.rst \
392         doc/cluster-merge.rst \
393         doc/design-2.0.rst \
394         doc/design-2.1.rst \
395         doc/design-2.2.rst \
396         doc/design-2.3.rst \
397         doc/design-2.4.rst \
398         doc/design-2.5.rst \
399         doc/design-2.6.rst \
400         doc/design-2.7.rst \
401         doc/design-autorepair.rst \
402         doc/design-bulk-create.rst \
403         doc/design-chained-jobs.rst \
404         doc/design-cpu-pinning.rst \
405         doc/design-device-uuid-name.rst \
406         doc/design-draft.rst \
407         doc/design-htools-2.3.rst \
408         doc/design-http-server.rst \
409         doc/design-impexp2.rst \
410         doc/design-lu-generated-jobs.rst \
411         doc/design-linuxha.rst \
412         doc/design-multi-reloc.rst \
413         doc/design-network.rst \
414         doc/design-node-add.rst \
415         doc/design-oob.rst \
416         doc/design-ovf-support.rst \
417         doc/design-opportunistic-locking.rst \
418         doc/design-partitioned.rst \
419         doc/design-query-splitting.rst \
420         doc/design-query2.rst \
421         doc/design-reason-trail.rst \
422         doc/design-resource-model.rst \
423         doc/design-restricted-commands.rst \
424         doc/design-shared-storage.rst \
425         doc/design-monitoring-agent.rst \
426         doc/design-virtual-clusters.rst \
427         doc/design-x509-ca.rst \
428         doc/design-hroller.rst \
429         doc/design-storagetypes.rst \
430         doc/devnotes.rst \
431         doc/glossary.rst \
432         doc/hooks.rst \
433         doc/iallocator.rst \
434         doc/index.rst \
435         doc/install-quick.rst \
436         doc/install.rst \
437         doc/locking.rst \
438         doc/manpages-disabled.rst \
439         doc/move-instance.rst \
440         doc/news.rst \
441         doc/ovfconverter.rst \
442         doc/rapi.rst \
443         doc/security.rst \
444         doc/upgrade.rst \
445         doc/virtual-cluster.rst \
446         doc/walkthrough.rst
447
448 # Generates file names such as "doc/man-gnt-instance.rst"
449 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
450
451 # Haskell programs to be installed in $PREFIX/bin
452 HS_BIN_PROGS=src/htools
453
454 # Haskell programs to be installed in the MYEXECLIB dir
455 HS_MYEXECLIB_PROGS=src/mon-collector
456
457 # Haskell programs to be compiled by "make really-all"
458 HS_COMPILE_PROGS= \
459         src/ganeti-mond \
460         src/hconfd \
461         src/rpc-test
462
463 # All Haskell non-test programs to be compiled but not automatically installed
464 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
465
466 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
467 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
468
469 HS_ALL_PROGS = \
470         $(HS_PROGS) \
471         test/hs/hpc-htools \
472         test/hs/hpc-mon-collector \
473         test/hs/htest \
474         $(HS_COMPILE_PROGS)
475
476 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
477 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
478
479 HFLAGS = \
480         -O -Wall -Werror -isrc \
481         -fwarn-monomorphism-restriction \
482         -fwarn-tabs \
483         $(GHC_BYVERSION_FLAGS)
484
485 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
486 HEXTRA =
487 # internal extra flags (used for test/hs/htest mainly)
488 HEXTRA_INT =
489 # exclude options for coverage reports
490 HPCEXCL = --exclude Main \
491         --exclude Ganeti.Constants \
492         --exclude Ganeti.HTools.QC \
493         --exclude Ganeti.THH \
494         --exclude Ganeti.Version \
495         --exclude Test.Ganeti.Attoparsec \
496         --exclude Test.Ganeti.TestCommon \
497         --exclude Test.Ganeti.TestHTools \
498         --exclude Test.Ganeti.TestHelper \
499         --exclude Test.Ganeti.TestImports \
500         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
501
502 HS_LIB_SRCS = \
503         src/Ganeti/Block/Drbd/Types.hs \
504         src/Ganeti/Block/Drbd/Parser.hs \
505         src/Ganeti/BasicTypes.hs \
506         src/Ganeti/Common.hs \
507         src/Ganeti/Compat.hs \
508         src/Ganeti/Confd/Client.hs \
509         src/Ganeti/Confd/Server.hs \
510         src/Ganeti/Confd/Types.hs \
511         src/Ganeti/Confd/Utils.hs \
512         src/Ganeti/Config.hs \
513         src/Ganeti/Curl/Multi.hs \
514         src/Ganeti/Daemon.hs \
515         src/Ganeti/DataCollectors/CLI.hs \
516         src/Ganeti/DataCollectors/Drbd.hs \
517         src/Ganeti/DataCollectors/Program.hs \
518         src/Ganeti/DataCollectors/Types.hs \
519         src/Ganeti/Errors.hs \
520         src/Ganeti/HTools/Backend/IAlloc.hs \
521         src/Ganeti/HTools/Backend/Luxi.hs \
522         src/Ganeti/HTools/Backend/Rapi.hs \
523         src/Ganeti/HTools/Backend/Simu.hs \
524         src/Ganeti/HTools/Backend/Text.hs \
525         src/Ganeti/HTools/CLI.hs \
526         src/Ganeti/HTools/Cluster.hs \
527         src/Ganeti/HTools/Container.hs \
528         src/Ganeti/HTools/ExtLoader.hs \
529         src/Ganeti/HTools/Graph.hs \
530         src/Ganeti/HTools/Group.hs \
531         src/Ganeti/HTools/Instance.hs \
532         src/Ganeti/HTools/Loader.hs \
533         src/Ganeti/HTools/Node.hs \
534         src/Ganeti/HTools/PeerMap.hs \
535         src/Ganeti/HTools/Program/Hail.hs \
536         src/Ganeti/HTools/Program/Harep.hs \
537         src/Ganeti/HTools/Program/Hbal.hs \
538         src/Ganeti/HTools/Program/Hcheck.hs \
539         src/Ganeti/HTools/Program/Hinfo.hs \
540         src/Ganeti/HTools/Program/Hscan.hs \
541         src/Ganeti/HTools/Program/Hspace.hs \
542         src/Ganeti/HTools/Program/Hroller.hs \
543         src/Ganeti/HTools/Program/Main.hs \
544         src/Ganeti/HTools/Types.hs \
545         src/Ganeti/Hypervisor/Xen/XmParser.hs \
546         src/Ganeti/Hypervisor/Xen/Types.hs \
547         src/Ganeti/Hash.hs \
548         src/Ganeti/JQueue.hs \
549         src/Ganeti/JSON.hs \
550         src/Ganeti/Jobs.hs \
551         src/Ganeti/Logging.hs \
552         src/Ganeti/Luxi.hs \
553         src/Ganeti/Monitoring/Server.hs \
554         src/Ganeti/Network.hs \
555         src/Ganeti/Objects.hs \
556         src/Ganeti/OpCodes.hs \
557         src/Ganeti/OpParams.hs \
558         src/Ganeti/Path.hs \
559         src/Ganeti/Query/Common.hs \
560         src/Ganeti/Query/Export.hs \
561         src/Ganeti/Query/Filter.hs \
562         src/Ganeti/Query/Group.hs \
563         src/Ganeti/Query/Job.hs \
564         src/Ganeti/Query/Language.hs \
565         src/Ganeti/Query/Network.hs \
566         src/Ganeti/Query/Node.hs \
567         src/Ganeti/Query/Query.hs \
568         src/Ganeti/Query/Server.hs \
569         src/Ganeti/Query/Types.hs \
570         src/Ganeti/Rpc.hs \
571         src/Ganeti/Runtime.hs \
572         src/Ganeti/Ssconf.hs \
573         src/Ganeti/THH.hs \
574         src/Ganeti/Types.hs \
575         src/Ganeti/Utils.hs
576
577 HS_TEST_SRCS = \
578         test/hs/Test/Ganeti/Attoparsec.hs \
579         test/hs/Test/Ganeti/BasicTypes.hs \
580         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
581         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
582         test/hs/Test/Ganeti/Common.hs \
583         test/hs/Test/Ganeti/Confd/Types.hs \
584         test/hs/Test/Ganeti/Confd/Utils.hs \
585         test/hs/Test/Ganeti/Daemon.hs \
586         test/hs/Test/Ganeti/Errors.hs \
587         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
588         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
589         test/hs/Test/Ganeti/HTools/CLI.hs \
590         test/hs/Test/Ganeti/HTools/Cluster.hs \
591         test/hs/Test/Ganeti/HTools/Container.hs \
592         test/hs/Test/Ganeti/HTools/Graph.hs \
593         test/hs/Test/Ganeti/HTools/Instance.hs \
594         test/hs/Test/Ganeti/HTools/Loader.hs \
595         test/hs/Test/Ganeti/HTools/Node.hs \
596         test/hs/Test/Ganeti/HTools/PeerMap.hs \
597         test/hs/Test/Ganeti/HTools/Types.hs \
598         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
599         test/hs/Test/Ganeti/JSON.hs \
600         test/hs/Test/Ganeti/Jobs.hs \
601         test/hs/Test/Ganeti/JQueue.hs \
602         test/hs/Test/Ganeti/Luxi.hs \
603         test/hs/Test/Ganeti/Network.hs \
604         test/hs/Test/Ganeti/Objects.hs \
605         test/hs/Test/Ganeti/OpCodes.hs \
606         test/hs/Test/Ganeti/Query/Filter.hs \
607         test/hs/Test/Ganeti/Query/Language.hs \
608         test/hs/Test/Ganeti/Query/Network.hs \
609         test/hs/Test/Ganeti/Query/Query.hs \
610         test/hs/Test/Ganeti/Rpc.hs \
611         test/hs/Test/Ganeti/Runtime.hs \
612         test/hs/Test/Ganeti/Ssconf.hs \
613         test/hs/Test/Ganeti/THH.hs \
614         test/hs/Test/Ganeti/TestCommon.hs \
615         test/hs/Test/Ganeti/TestHTools.hs \
616         test/hs/Test/Ganeti/TestHelper.hs \
617         test/hs/Test/Ganeti/Types.hs \
618         test/hs/Test/Ganeti/Utils.hs
619
620 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
621
622 HS_BUILT_SRCS = \
623         test/hs/Test/Ganeti/TestImports.hs \
624         src/Ganeti/Constants.hs \
625         src/Ganeti/Curl/Internal.hs \
626         src/Ganeti/Version.hs
627 HS_BUILT_SRCS_IN = \
628         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
629         src/Ganeti/Curl/Internal.hsc
630
631 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
632
633 $(RUN_IN_TEMPDIR): | stamp-directories
634
635 doc/html/index.html: ENABLE_MANPAGES =
636 doc/man-html/index.html: ENABLE_MANPAGES = 1
637 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
638
639 # Note: we use here an order-only prerequisite, as the contents of
640 # _autoconf.py are not actually influencing the html build output: it
641 # has to exist in order for the sphinx module to be loaded
642 # successfully, but we certainly don't want the docs to be rebuilt if
643 # it changes
644 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
645         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
646         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
647         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
648         | $(BUILT_PYTHON_SOURCES)
649         @test -n "$(SPHINX)" || \
650             { echo 'sphinx-build' not found during configure; exit 1; }
651 if !MANPAGES_IN_DOC
652         if test -n '$(ENABLE_MANPAGES)'; then \
653           echo 'Man pages in documentation were disabled at configure time' >&2; \
654           exit 1; \
655         fi
656 endif
657 ## Sphinx provides little control over what content should be included. Some
658 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
659 ## build two different versions of the documentation--once without man pages and
660 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
661 ## us with this, but requires running in a temporary directory. It moves the
662 ## correct files into place depending on environment variables.
663         dir=$(dir $@) && \
664         @mkdir_p@ $$dir && \
665         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
666         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
667             -d . \
668             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
669             -D release="$(PACKAGE_VERSION)" \
670             -D graphviz_dot="$(DOT)" \
671             -D enable_manpages="$(ENABLE_MANPAGES)" \
672             doc $(CURDIR)/$$dir && \
673         rm -f $$dir/.buildinfo $$dir/objects.inv
674         touch $@
675
676 doc/html: doc/html/index.html
677
678 doc/man-html: doc/man-html/index.html
679
680 doc/install-quick.rst: INSTALL
681 doc/news.rst: NEWS
682 doc/upgrade.rst: UPGRADE
683
684 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
685         set -e; \
686         { echo '.. This file is automatically updated at build time from $<.'; \
687           echo '.. Do not edit.'; \
688           echo; \
689           cat $<; \
690         } > $@
691
692 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
693         { echo '.. This file is automatically generated, do not edit!'; \
694           echo ''; \
695           echo 'Man pages'; \
696           echo '========='; \
697           echo; \
698           echo '.. toctree::'; \
699           echo '   :maxdepth: 1'; \
700           echo; \
701           for i in $(notdir $(mandocrst)); do \
702             echo "   $$i"; \
703           done | LC_ALL=C sort; \
704         } > $@
705
706 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
707 if MANPAGES_IN_DOC
708         { echo '.. This file is automatically updated at build time from $<.'; \
709           echo '.. Do not edit.'; \
710           echo; \
711           echo "$*"; \
712           echo '=========================================='; \
713           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
714         } > $@
715 else
716         echo 'Man pages in documentation were disabled at configure time' >&2; \
717         exit 1;
718 endif
719
720 # Things to build but not to install (add it to EXTRA_DIST if it should be
721 # distributed)
722 noinst_DATA = \
723         doc/html \
724         $(BUILT_EXAMPLES) \
725         doc/examples/bash_completion \
726         doc/examples/bash_completion-debug \
727         $(manhtml)
728
729 if MANPAGES_IN_DOC
730 noinst_DATA += doc/man-html
731 endif
732
733 gnt_scripts = \
734         scripts/gnt-backup \
735         scripts/gnt-cluster \
736         scripts/gnt-debug \
737         scripts/gnt-group \
738         scripts/gnt-instance \
739         scripts/gnt-job \
740         scripts/gnt-network \
741         scripts/gnt-node \
742         scripts/gnt-os \
743         scripts/gnt-storage
744
745 PYTHON_BOOTSTRAP_SBIN = \
746         daemons/ganeti-masterd \
747         daemons/ganeti-noded \
748         daemons/ganeti-rapi \
749         daemons/ganeti-watcher \
750         $(gnt_scripts)
751
752 PYTHON_BOOTSTRAP = \
753         $(PYTHON_BOOTSTRAP_SBIN) \
754         tools/burnin \
755         tools/ensure-dirs \
756         tools/node-cleanup \
757         tools/node-daemon-setup \
758         tools/prepare-node-join
759
760 qa_scripts = \
761         qa/__init__.py \
762         qa/ganeti-qa.py \
763         qa/qa_cluster.py \
764         qa/qa_config.py \
765         qa/qa_daemon.py \
766         qa/qa_env.py \
767         qa/qa_error.py \
768         qa/qa_group.py \
769         qa/qa_instance.py \
770         qa/qa_job.py \
771         qa/qa_node.py \
772         qa/qa_os.py \
773         qa/qa_rapi.py \
774         qa/qa_tags.py \
775         qa/qa_utils.py
776
777 bin_SCRIPTS =
778 if WANT_HTOOLS
779 bin_SCRIPTS += $(HS_BIN_PROGS)
780 install-exec-hook:
781         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
782 # FIXME: this is a hardcoded logic, instead of auto-resolving
783         $(LN_S) -f ../../../bin/htools \
784           $(DESTDIR)$(iallocatorsdir)/hail
785         for role in $(HS_BIN_ROLES); do \
786           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
787         done
788 endif
789
790 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
791         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
792           echo "Error: cannot run unittests without the development" \
793                " libraries (see devnotes.rst)" 1>&2; \
794           exit 1; \
795         fi
796         @rm -f $(notdir $@).tix
797         $(GHC) --make \
798           $(HFLAGS) \
799           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
800           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
801           $(HEXTRA) $(HEXTRA_INT) $@
802         @touch "$@"
803
804 # for the test/hs/htest binary, we need to enable profiling/coverage
805 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
806
807 # we compile the hpc-htools binary with the program coverage
808 test/hs/hpc-htools: HEXTRA_INT=-fhpc
809
810 # we compile the hpc-mon-collector binary with the program coverage
811 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
812
813 # test dependency
814 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
815
816 # rules for building profiling-enabled versions of the haskell
817 # programs: hs-prof does the full two-step build, whereas
818 # hs-prof-quick does only the final rebuild (hs-prof must have been
819 # run before)
820 .PHONY: hs-prof hs-prof-quick
821 hs-prof:
822         @if [ -z "$(TARGET)" ]; then \
823           echo "You need to define TARGET when running this rule" 1>&2; \
824           exit 1; \
825         fi
826         $(MAKE) $(AM_MAKEFLAGS) clean
827         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
828         rm -f $(HS_ALL_PROGS)
829         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
830
831 hs-prof-quick:
832         @if [ -z "$(TARGET)" ]; then \
833           echo "You need to define TARGET when running this rule" 1>&2; \
834           exit 1; \
835         fi
836         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
837
838 dist_sbin_SCRIPTS = \
839         tools/ganeti-listrunner
840
841 nodist_sbin_SCRIPTS = \
842         $(PYTHON_BOOTSTRAP_SBIN) \
843         daemons/ganeti-cleaner
844
845 if ENABLE_CONFD
846 src/ganeti-confd: src/hconfd
847         cp -f $< $@
848
849 nodist_sbin_SCRIPTS += src/ganeti-confd
850 endif
851
852 if ENABLE_MOND
853 nodist_sbin_SCRIPTS += src/ganeti-mond
854 endif
855
856 python_scripts = \
857         tools/cfgshell \
858         tools/cfgupgrade \
859         tools/cfgupgrade12 \
860         tools/cluster-merge \
861         tools/confd-client \
862         tools/fmtjson \
863         tools/lvmstrap \
864         tools/move-instance \
865         tools/ovfconverter \
866         tools/sanitize-config
867
868 dist_tools_SCRIPTS = \
869         $(python_scripts) \
870         tools/burnin \
871         tools/kvm-console-wrapper \
872         tools/master-ip-setup \
873         tools/xen-console-wrapper
874
875 nodist_tools_python_scripts = \
876         tools/node-cleanup
877
878 nodist_tools_SCRIPTS = \
879         $(nodist_tools_python_scripts) \
880         tools/users-setup \
881         tools/vcluster-setup
882
883 pkglib_python_scripts = \
884         daemons/import-export \
885         tools/check-cert-expired
886
887 nodist_pkglib_python_scripts = \
888         tools/ensure-dirs \
889         tools/node-daemon-setup \
890         tools/prepare-node-join
891
892 myexeclib_SCRIPTS = \
893         daemons/daemon-util \
894         tools/kvm-ifup \
895         $(pkglib_python_scripts) \
896         $(HS_MYEXECLIB_PROGS)
897
898 nodist_myexeclib_SCRIPTS = \
899         $(nodist_pkglib_python_scripts)
900
901 EXTRA_DIST = \
902         NEWS \
903         UPGRADE \
904         epydoc.conf.in \
905         pylintrc \
906         autotools/build-bash-completion \
907         autotools/build-rpc \
908         autotools/check-header \
909         autotools/check-imports \
910         autotools/check-man-dashes \
911         autotools/check-man-references \
912         autotools/check-man-warnings \
913         autotools/check-news \
914         autotools/check-python-code \
915         autotools/check-tar \
916         autotools/check-version \
917         autotools/convert-constants \
918         autotools/docpp \
919         autotools/gen-py-coverage \
920         autotools/sphinx-wrapper \
921         autotools/testrunner \
922         autotools/wrong-hardcoded-paths \
923         $(RUN_IN_TEMPDIR) \
924         daemons/daemon-util.in \
925         daemons/ganeti-cleaner.in \
926         $(pkglib_python_scripts) \
927         devel/upload \
928         devel/webserver \
929         tools/kvm-ifup.in \
930         tools/users-setup.in \
931         tools/vcluster-setup.in \
932         $(docinput) \
933         doc/html \
934         $(BUILT_EXAMPLES:%=%.in) \
935         doc/examples/ganeti.default \
936         doc/examples/ganeti.default-debug \
937         doc/examples/hooks/ethers \
938         doc/examples/gnt-debug/README \
939         doc/examples/gnt-debug/delay0.json \
940         doc/examples/gnt-debug/delay50.json \
941         test/py/lockperf.py \
942         test/py/testutils.py \
943         test/py/mocks.py \
944         $(dist_TESTS) \
945         $(TEST_FILES) \
946         man/footer.rst \
947         $(manrst) \
948         $(maninput) \
949         qa/qa-sample.json \
950         $(qa_scripts) \
951         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
952         $(HS_PROG_SRCS) \
953         src/lint-hints.hs \
954         test/hs/cli-tests-defs.sh \
955         test/hs/offline-test.sh \
956         .ghci
957
958 man_MANS = \
959         man/ganeti-cleaner.8 \
960         man/ganeti-confd.8 \
961         man/ganeti-listrunner.8 \
962         man/ganeti-masterd.8 \
963         man/ganeti-mond.8 \
964         man/ganeti-noded.8 \
965         man/ganeti-os-interface.7 \
966         man/ganeti-extstorage-interface.7 \
967         man/ganeti-rapi.8 \
968         man/ganeti-watcher.8 \
969         man/ganeti.7 \
970         man/gnt-backup.8 \
971         man/gnt-cluster.8 \
972         man/gnt-debug.8 \
973         man/gnt-group.8 \
974         man/gnt-network.8 \
975         man/gnt-instance.8 \
976         man/gnt-job.8 \
977         man/gnt-node.8 \
978         man/gnt-os.8 \
979         man/gnt-storage.8 \
980         man/hail.1 \
981         man/hbal.1 \
982         man/hcheck.1 \
983         man/hinfo.1 \
984         man/hscan.1 \
985         man/hspace.1 \
986         man/hroller.1 \
987         man/htools.1 \
988         man/mon-collector.7
989
990 # Remove extensions from all filenames in man_MANS
991 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
992
993 manrst = $(patsubst %,%.rst,$(mannoext))
994 manhtml = $(patsubst %.rst,%.html,$(manrst))
995 mangen = $(patsubst %.rst,%.gen,$(manrst))
996 maninput = \
997         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
998         $(patsubst %.html,%.html.in,$(manhtml)) \
999         $(mangen)
1000
1001 TEST_FILES = \
1002         test/data/htools/clean-nonzero-score.data \
1003         test/data/htools/common-suffix.data \
1004         test/data/htools/empty-cluster.data \
1005         test/data/htools/hail-alloc-drbd.json \
1006         test/data/htools/hail-alloc-invalid-twodisks.json \
1007         test/data/htools/hail-alloc-twodisks.json \
1008         test/data/htools/hail-change-group.json \
1009         test/data/htools/hail-invalid-reloc.json \
1010         test/data/htools/hail-node-evac.json \
1011         test/data/htools/hail-reloc-drbd.json \
1012         test/data/htools/hbal-excl-tags.data \
1013         test/data/htools/hbal-split-insts.data \
1014         test/data/htools/invalid-node.data \
1015         test/data/htools/missing-resources.data \
1016         test/data/htools/multiple-master.data \
1017         test/data/htools/n1-failure.data \
1018         test/data/htools/rapi/groups.json \
1019         test/data/htools/rapi/info.json \
1020         test/data/htools/rapi/instances.json \
1021         test/data/htools/rapi/nodes.json \
1022         test/data/htools/unique-reboot-order.data \
1023         test/hs/shelltests/htools-balancing.test \
1024         test/hs/shelltests/htools-basic.test \
1025         test/hs/shelltests/htools-dynutil.test \
1026         test/hs/shelltests/htools-excl.test \
1027         test/hs/shelltests/htools-hail.test \
1028         test/hs/shelltests/htools-hroller.test \
1029         test/hs/shelltests/htools-hspace.test \
1030         test/hs/shelltests/htools-invalid.test \
1031         test/hs/shelltests/htools-multi-group.test \
1032         test/hs/shelltests/htools-no-backend.test \
1033         test/hs/shelltests/htools-rapi.test \
1034         test/hs/shelltests/htools-single-group.test \
1035         test/hs/shelltests/htools-text-backend.test \
1036         test/hs/shelltests/htools-mon-collector.test \
1037         test/data/bdev-drbd-8.0.txt \
1038         test/data/bdev-drbd-8.3.txt \
1039         test/data/bdev-drbd-8.4.txt \
1040         test/data/bdev-drbd-disk.txt \
1041         test/data/bdev-drbd-net-ip4.txt \
1042         test/data/bdev-drbd-net-ip6.txt \
1043         test/data/bdev-rbd/json_output_empty.txt \
1044         test/data/bdev-rbd/json_output_extra_matches.txt \
1045         test/data/bdev-rbd/json_output_no_matches.txt \
1046         test/data/bdev-rbd/json_output_ok.txt \
1047         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1048         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1049         test/data/bdev-rbd/plain_output_new_ok.txt \
1050         test/data/bdev-rbd/plain_output_old_empty.txt \
1051         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1052         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1053         test/data/bdev-rbd/plain_output_old_ok.txt \
1054         test/data/bdev-rbd/output_invalid.txt \
1055         test/data/cert1.pem \
1056         test/data/cert2.pem \
1057         test/data/instance-minor-pairing.txt \
1058         test/data/ip-addr-show-dummy0.txt \
1059         test/data/ip-addr-show-lo-ipv4.txt \
1060         test/data/ip-addr-show-lo-ipv6.txt \
1061         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1062         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1063         test/data/ip-addr-show-lo-oneline.txt \
1064         test/data/ip-addr-show-lo.txt \
1065         test/data/kvm_0.12.5_help.txt \
1066         test/data/kvm_0.15.90_help.txt \
1067         test/data/kvm_0.9.1_help.txt \
1068         test/data/kvm_0.9.1_help_boot_test.txt \
1069         test/data/kvm_1.0_help.txt \
1070         test/data/kvm_1.1.2_help.txt \
1071         test/data/ovfdata/compr_disk.vmdk.gz \
1072         test/data/ovfdata/config.ini \
1073         test/data/ovfdata/corrupted_resources.ovf \
1074         test/data/ovfdata/empty.ini \
1075         test/data/ovfdata/empty.ovf \
1076         test/data/ovfdata/ganeti.mf \
1077         test/data/ovfdata/ganeti.ovf \
1078         test/data/ovfdata/gzip_disk.ovf \
1079         test/data/ovfdata/new_disk.vmdk \
1080         test/data/ovfdata/no_disk.ini \
1081         test/data/ovfdata/no_disk_in_ref.ovf \
1082         test/data/ovfdata/no_os.ini \
1083         test/data/ovfdata/no_ovf.ova \
1084         test/data/ovfdata/other/rawdisk.raw \
1085         test/data/ovfdata/ova.ova \
1086         test/data/ovfdata/rawdisk.raw \
1087         test/data/ovfdata/second_disk.vmdk \
1088         test/data/ovfdata/unsafe_path.ini \
1089         test/data/ovfdata/virtualbox.ovf \
1090         test/data/ovfdata/wrong_config.ini \
1091         test/data/ovfdata/wrong_extension.ovd \
1092         test/data/ovfdata/wrong_manifest.mf \
1093         test/data/ovfdata/wrong_manifest.ovf \
1094         test/data/ovfdata/wrong_ova.ova \
1095         test/data/ovfdata/wrong_xml.ovf \
1096         test/data/proc_drbd8.txt \
1097         test/data/proc_drbd80-emptyline.txt \
1098         test/data/proc_drbd80-emptyversion.txt \
1099         test/data/proc_drbd83.txt \
1100         test/data/proc_drbd83_sync.txt \
1101         test/data/proc_drbd83_sync_want.txt \
1102         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1103         test/data/proc_drbd84.txt \
1104         test/data/proc_drbd84_sync.txt \
1105         test/data/qa-minimal-nodes-instances-only.json \
1106         test/data/sys_drbd_usermode_helper.txt \
1107         test/data/vgreduce-removemissing-2.02.02.txt \
1108         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1109         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1110         test/data/vgs-missing-pvs-2.02.02.txt \
1111         test/data/vgs-missing-pvs-2.02.66.txt \
1112         test/data/xen-xm-info-4.0.1.txt \
1113         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1114         test/data/xen-xm-list-4.0.1-four-instances.txt \
1115         test/data/xen-xm-list-long-4.0.1.txt \
1116         test/data/xen-xm-uptime-4.0.1.txt \
1117         test/py/ganeti-cli.test \
1118         test/py/gnt-cli.test \
1119         test/py/import-export_unittest-helper
1120
1121 python_tests = \
1122         doc/examples/rapi_testutils.py \
1123         test/py/cfgupgrade_unittest.py \
1124         test/py/docs_unittest.py \
1125         test/py/ganeti.asyncnotifier_unittest.py \
1126         test/py/ganeti.backend_unittest-runasroot.py \
1127         test/py/ganeti.backend_unittest.py \
1128         test/py/ganeti.block.bdev_unittest.py \
1129         test/py/ganeti.cli_unittest.py \
1130         test/py/ganeti.client.gnt_cluster_unittest.py \
1131         test/py/ganeti.client.gnt_instance_unittest.py \
1132         test/py/ganeti.client.gnt_job_unittest.py \
1133         test/py/ganeti.cmdlib_unittest.py \
1134         test/py/ganeti.compat_unittest.py \
1135         test/py/ganeti.confd.client_unittest.py \
1136         test/py/ganeti.config_unittest.py \
1137         test/py/ganeti.constants_unittest.py \
1138         test/py/ganeti.daemon_unittest.py \
1139         test/py/ganeti.errors_unittest.py \
1140         test/py/ganeti.hooks_unittest.py \
1141         test/py/ganeti.ht_unittest.py \
1142         test/py/ganeti.http_unittest.py \
1143         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1144         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1145         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1146         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1147         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1148         test/py/ganeti.hypervisor_unittest.py \
1149         test/py/ganeti.impexpd_unittest.py \
1150         test/py/ganeti.jqueue_unittest.py \
1151         test/py/ganeti.jstore_unittest.py \
1152         test/py/ganeti.locking_unittest.py \
1153         test/py/ganeti.luxi_unittest.py \
1154         test/py/ganeti.masterd.iallocator_unittest.py \
1155         test/py/ganeti.masterd.instance_unittest.py \
1156         test/py/ganeti.mcpu_unittest.py \
1157         test/py/ganeti.netutils_unittest.py \
1158         test/py/ganeti.objects_unittest.py \
1159         test/py/ganeti.opcodes_unittest.py \
1160         test/py/ganeti.outils_unittest.py \
1161         test/py/ganeti.ovf_unittest.py \
1162         test/py/ganeti.qlang_unittest.py \
1163         test/py/ganeti.query_unittest.py \
1164         test/py/ganeti.rapi.baserlib_unittest.py \
1165         test/py/ganeti.rapi.client_unittest.py \
1166         test/py/ganeti.rapi.resources_unittest.py \
1167         test/py/ganeti.rapi.rlib2_unittest.py \
1168         test/py/ganeti.rapi.testutils_unittest.py \
1169         test/py/ganeti.rpc_unittest.py \
1170         test/py/ganeti.runtime_unittest.py \
1171         test/py/ganeti.serializer_unittest.py \
1172         test/py/ganeti.server.rapi_unittest.py \
1173         test/py/ganeti.ssconf_unittest.py \
1174         test/py/ganeti.ssh_unittest.py \
1175         test/py/ganeti.storage_unittest.py \
1176         test/py/ganeti.tools.burnin_unittest.py \
1177         test/py/ganeti.tools.ensure_dirs_unittest.py \
1178         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1179         test/py/ganeti.tools.prepare_node_join_unittest.py \
1180         test/py/ganeti.uidpool_unittest.py \
1181         test/py/ganeti.utils.algo_unittest.py \
1182         test/py/ganeti.utils.filelock_unittest.py \
1183         test/py/ganeti.utils.hash_unittest.py \
1184         test/py/ganeti.utils.io_unittest-runasroot.py \
1185         test/py/ganeti.utils.io_unittest.py \
1186         test/py/ganeti.utils.log_unittest.py \
1187         test/py/ganeti.utils.lvm_unittest.py \
1188         test/py/ganeti.utils.mlock_unittest.py \
1189         test/py/ganeti.utils.nodesetup_unittest.py \
1190         test/py/ganeti.utils.process_unittest.py \
1191         test/py/ganeti.utils.retry_unittest.py \
1192         test/py/ganeti.utils.text_unittest.py \
1193         test/py/ganeti.utils.wrapper_unittest.py \
1194         test/py/ganeti.utils.x509_unittest.py \
1195         test/py/ganeti.utils_unittest.py \
1196         test/py/ganeti.vcluster_unittest.py \
1197         test/py/ganeti.workerpool_unittest.py \
1198         test/py/pycurl_reset_unittest.py \
1199         test/py/qa.qa_config_unittest.py \
1200         test/py/tempfile_fork_unittest.py
1201
1202 haskell_tests = test/hs/htest
1203
1204 dist_TESTS = \
1205         test/py/check-cert-expired_unittest.bash \
1206         test/py/daemon-util_unittest.bash \
1207         test/py/ganeti-cleaner_unittest.bash \
1208         test/py/import-export_unittest.bash \
1209         test/py/cli-test.bash \
1210         test/py/bash_completion.bash \
1211         $(python_tests)
1212
1213 nodist_TESTS =
1214 check_SCRIPTS =
1215
1216 if WANT_HSTESTS
1217 nodist_TESTS += $(haskell_tests)
1218 dist_TESTS += test/hs/offline-test.sh
1219 check_SCRIPTS += \
1220         test/hs/hpc-htools \
1221         test/hs/hpc-mon-collector \
1222         $(HS_BUILT_TEST_HELPERS)
1223 endif
1224
1225 TESTS = $(dist_TESTS) $(nodist_TESTS)
1226
1227 # Environment for all tests
1228 PLAIN_TESTS_ENVIRONMENT = \
1229         PYTHONPATH=. \
1230         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1231         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1232         $(RUN_IN_TEMPDIR)
1233
1234 # Environment for tests run by automake
1235 TESTS_ENVIRONMENT = \
1236         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1237
1238 all_python_code = \
1239         $(dist_sbin_SCRIPTS) \
1240         $(python_scripts) \
1241         $(pkglib_python_scripts) \
1242         $(nodist_pkglib_python_scripts) \
1243         $(nodist_tools_python_scripts) \
1244         $(python_tests) \
1245         $(pkgpython_PYTHON) \
1246         $(client_PYTHON) \
1247         $(hypervisor_PYTHON) \
1248         $(block_PYTHON) \
1249         $(rapi_PYTHON) \
1250         $(server_PYTHON) \
1251         $(pytools_PYTHON) \
1252         $(http_PYTHON) \
1253         $(confd_PYTHON) \
1254         $(masterd_PYTHON) \
1255         $(impexpd_PYTHON) \
1256         $(utils_PYTHON) \
1257         $(watcher_PYTHON) \
1258         $(noinst_PYTHON) \
1259         $(qa_scripts)
1260
1261 srclink_files = \
1262         man/footer.rst \
1263         test/py/check-cert-expired_unittest.bash \
1264         test/py/daemon-util_unittest.bash \
1265         test/py/ganeti-cleaner_unittest.bash \
1266         test/py/import-export_unittest.bash \
1267         test/py/cli-test.bash \
1268         test/py/bash_completion.bash \
1269         test/hs/offline-test.sh \
1270         test/hs/cli-tests-defs.sh \
1271         $(all_python_code) \
1272         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1273         $(docinput)
1274
1275 check_python_code = \
1276         $(BUILD_BASH_COMPLETION) \
1277         $(CHECK_IMPORTS) \
1278         $(CHECK_HEADER) \
1279         $(DOCPP) \
1280         $(all_python_code)
1281
1282 lint_python_code = \
1283         ganeti \
1284         ganeti/http/server.py \
1285         $(dist_sbin_SCRIPTS) \
1286         $(python_scripts) \
1287         $(pkglib_python_scripts) \
1288         $(BUILD_BASH_COMPLETION) \
1289         $(CHECK_IMPORTS) \
1290         $(CHECK_HEADER) \
1291         $(DOCPP) \
1292         $(PYTHON_BOOTSTRAP)
1293
1294 standalone_python_modules = \
1295         lib/rapi/client.py \
1296         tools/ganeti-listrunner
1297
1298 pep8_python_code = \
1299         ganeti \
1300         ganeti/http/server.py \
1301         $(dist_sbin_SCRIPTS) \
1302         $(python_scripts) \
1303         $(pkglib_python_scripts) \
1304         $(BUILD_BASH_COMPLETION) \
1305         $(CHECK_HEADER) \
1306         $(DOCPP) \
1307         $(PYTHON_BOOTSTRAP) \
1308         qa
1309
1310 test/py/daemon-util_unittest.bash: daemons/daemon-util
1311
1312 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1313
1314 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1315
1316 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1317         sed -f $(REPLACE_VARS_SED) < $< > $@
1318         chmod +x $@
1319
1320 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1321         sed -f $(REPLACE_VARS_SED) < $< > $@
1322         chmod +x $@
1323
1324 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1325         sed -f $(REPLACE_VARS_SED) < $< > $@
1326         chmod +x $@
1327
1328 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1329         sed -f $(REPLACE_VARS_SED) < $< > $@
1330         chmod +x $@
1331
1332 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1333         sed -f $(REPLACE_VARS_SED) < $< > $@
1334
1335 doc/examples/bash_completion: BC_ARGS = --compact
1336 doc/examples/bash_completion-debug: BC_ARGS =
1337
1338 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1339         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1340         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1341         daemons/ganeti-cleaner \
1342         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1343         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1344           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1345
1346 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1347         lib/build/shell_example_lexer.py \
1348         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1349         @echo "Checking $< for hardcoded paths..."
1350         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1351           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1352           exit 1; \
1353         fi
1354         set -e ; \
1355         trap 'echo auto-removing $@; rm $@' EXIT; \
1356         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1357         $(CHECK_MAN_REFERENCES) $@; \
1358         trap - EXIT
1359
1360 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1361         @test -n "$(PANDOC)" || \
1362           { echo 'pandoc' not found during configure; exit 1; }
1363         set -o pipefail -e; \
1364         trap 'echo auto-removing $@; rm $@' EXIT; \
1365         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1366           sed -e 's/\\@/@/g' > $@; \
1367         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1368         $(CHECK_MAN_DASHES) $@; \
1369         trap - EXIT
1370
1371 man/%.html.in: man/%.gen man/footer.rst
1372         @test -n "$(PANDOC)" || \
1373           { echo 'pandoc' not found during configure; exit 1; }
1374         set -o pipefail ; \
1375         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1376           sed -e 's/\\@/@/g' > $@
1377
1378 man/%: man/%.in  $(REPLACE_VARS_SED)
1379         sed -f $(REPLACE_VARS_SED) < $< > $@
1380
1381 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1382         sed -f $(REPLACE_VARS_SED) < $< > $@
1383
1384 vcs-version:
1385         if test -d .git; then \
1386           git describe > $@; \
1387         elif test ! -f $@ ; then \
1388           echo "Cannot auto-generate $@ file"; exit 1; \
1389         fi
1390
1391 .PHONY: clean-vcs-version
1392 clean-vcs-version:
1393         rm -f vcs-version
1394
1395 .PHONY: regen-vcs-version
1396 regen-vcs-version:
1397         @set -e; \
1398         cd $(srcdir); \
1399         if test -d .git; then \
1400           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1401           git describe > $$T; \
1402           if ! cmp --quiet $$T vcs-version; then \
1403             mv $$T vcs-version; \
1404           fi; \
1405         fi
1406
1407 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1408         vcs-version $(built_base_sources)
1409         set -e; \
1410         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1411         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1412
1413 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1414         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1415         lib/jstore.py $(RUN_IN_TEMPDIR) \
1416         $(CONVERT_CONSTANTS) $(built_base_sources) \
1417         | lib/_vcsversion.py
1418         set -e; \
1419         { cat $< ; \
1420           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1421         } > $@
1422
1423 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1424         hsc2hs -o $@ $<
1425
1426 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1427         $(built_base_sources)
1428         set -e; \
1429         { cat $< ; \
1430           echo ; \
1431           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1432             echo "import $$name ()" ; \
1433           done ; \
1434         } > $@
1435
1436 lib/_autoconf.py: Makefile | stamp-directories
1437         set -e; \
1438         { echo '# This file is automatically generated, do not edit!'; \
1439           echo '#'; \
1440           echo ''; \
1441           echo '"""Build-time configuration for Ganeti.'; \
1442           echo '';\
1443           echo 'This file is autogenerated by the build process.'; \
1444           echo 'For any changes you need to re-run ./configure (and'; \
1445           echo 'not edit by hand).'; \
1446           echo ''; \
1447           echo '"""'; \
1448           echo ''; \
1449           echo '# pylint: disable=C0301,C0324'; \
1450           echo '# because this is autogenerated, we do not want'; \
1451           echo '# style warnings' ; \
1452           echo ''; \
1453           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1454           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1455           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1456           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1457           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1458           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1459           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1460           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1461           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1462           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1463           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1464           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1465           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1466           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1467           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1468           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1469           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1470           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1471           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1472           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1473           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1474           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1475           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1476           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1477           echo "KVM_PATH = '$(KVM_PATH)'"; \
1478           echo "IP_PATH = '$(IP_PATH)'"; \
1479           echo "SOCAT_PATH = '$(SOCAT)'"; \
1480           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1481           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1482           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1483           echo "TOOLSDIR = '$(toolsdir)'"; \
1484           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1485           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1486           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1487           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1488           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1489           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1490           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1491           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1492           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1493           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1494           echo "RAPI_USER = '$(RAPI_USER)'"; \
1495           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1496           echo "CONFD_USER = '$(CONFD_USER)'"; \
1497           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1498           echo "NODED_USER = '$(NODED_USER)'"; \
1499           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1500           echo "MOND_USER = '$(MOND_USER)'"; \
1501           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1502           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1503           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1504           echo "HTOOLS = True"; \
1505           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1506           echo "XEN_CMD = '$(XEN_CMD)'"; \
1507           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1508           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1509           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1510 ## Write dictionary with man page name as the key and the section number as the
1511 ## value
1512           echo "MAN_PAGES = {"; \
1513           for i in $(notdir $(man_MANS)); do \
1514             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1515           done; \
1516           echo "}"; \
1517         } > $@
1518
1519 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1520         set -e; \
1521         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1522         { echo '# This file is automatically generated, do not edit!'; \
1523           echo '#'; \
1524           echo ''; \
1525           echo '"""Build-time VCS version number for Ganeti.'; \
1526           echo '';\
1527           echo 'This file is autogenerated by the build process.'; \
1528           echo 'For any changes you need to re-run ./configure (and'; \
1529           echo 'not edit by hand).'; \
1530           echo ''; \
1531           echo '"""'; \
1532           echo ''; \
1533           echo '# pylint: disable=C0301,C0324'; \
1534           echo '# because this is autogenerated, we do not want'; \
1535           echo '# style warnings' ; \
1536           echo ''; \
1537           echo "VCS_VERSION = '$$VCSVER'"; \
1538         } > $@
1539
1540 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1541         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1542
1543 $(SHELL_ENV_INIT): Makefile stamp-directories
1544         set -e; \
1545         { echo '# Allow overriding for tests'; \
1546           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1547           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1548           echo; \
1549           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1550           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1551           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1552           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1553           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1554         } > $@
1555
1556 ## Writes sed script to replace placeholders with build-time values. The
1557 ## additional quotes after the first @ sign are necessary to stop configure
1558 ## from replacing those values as well.
1559 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1560         set -e; \
1561         { echo 's#@''PREFIX@#$(prefix)#g'; \
1562           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1563           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1564           echo 's#@''BINDIR@#$(bindir)#g'; \
1565           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1566           echo 's#@''LIBDIR@#$(libdir)#g'; \
1567           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1568           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1569           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1570           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1571           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1572           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1573           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1574           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1575           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1576           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1577           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1578           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1579           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1580           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1581           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1582           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1583           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1584           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1585           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1586           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1587           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1588           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1589           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1590           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1591           echo; \
1592           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1593           echo '  r $(SHELL_ENV_INIT)'; \
1594           echo '  d'; \
1595           echo '}'; \
1596         } > $@
1597
1598 # Using deferred evaluation
1599 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1600 daemons/ganeti-watcher: MODULE = ganeti.watcher
1601 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1602 tools/burnin: MODULE = ganeti.tools.burnin
1603 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1604 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1605 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1606 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1607 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1608
1609 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1610         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1611         set -e; \
1612         { echo '#!/usr/bin/python'; \
1613           echo '# This file is automatically generated, do not edit!'; \
1614           echo "# Edit $(MODULE) instead."; \
1615           echo; \
1616           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1617           echo; \
1618           echo '# pylint: disable=C0103'; \
1619           echo '# C0103: Invalid name'; \
1620           echo; \
1621           echo 'import sys'; \
1622           echo 'import $(MODULE) as main'; \
1623           echo; \
1624           echo '# Temporarily alias commands until bash completion'; \
1625           echo '# generator is changed'; \
1626           echo 'if hasattr(main, "commands"):'; \
1627           echo '  commands = main.commands # pylint: disable=E1101'; \
1628           echo 'if hasattr(main, "aliases"):'; \
1629           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1630           echo; \
1631           echo 'if __name__ == "__main__":'; \
1632           echo '  sys.exit(main.Main())'; \
1633         } > $@
1634         chmod u+x $@
1635
1636 $(HS_BUILT_TEST_HELPERS): Makefile
1637         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1638         set -e; \
1639         { echo '#!/bin/sh'; \
1640           echo '# This file is automatically generated, do not edit!'; \
1641           echo "# Edit Makefile.am instead."; \
1642           echo; \
1643           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1644         } > $@
1645         chmod u+x $@
1646
1647 stamp-directories: Makefile
1648         $(MAKE) $(AM_MAKEFLAGS) ganeti
1649         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1650         touch $@
1651
1652 # We need to create symlinks because "make distcheck" will not install Python
1653 # files when building.
1654 stamp-srclinks: Makefile | stamp-directories
1655         set -e; \
1656         for i in $(srclink_files); do \
1657           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1658             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1659           fi; \
1660         done
1661         touch $@
1662
1663 .PHONY: ganeti
1664 ganeti:
1665         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1666
1667 .PHONY: check-dirs
1668 check-dirs: $(GENERATED_FILES)
1669         @set -e; \
1670         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1671           error=; \
1672           while read dir; do \
1673             case "$$dir" in \
1674               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1675               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1676             esac; \
1677           done; \
1678           for dir in $(DIRS); do \
1679             if ! test -d "$$dir"; then \
1680               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1681               error=1; \
1682             fi \
1683           done; \
1684           test -z "$$error"; \
1685         }
1686
1687 .PHONY: check-local
1688 check-local: check-dirs $(GENERATED_FILES)
1689         $(CHECK_PYTHON_CODE) $(check_python_code)
1690         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1691         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1692         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1693         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1694         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1695         error= ; \
1696         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1697           echo "Incorrect version in README, expected $$expver" >&2; \
1698           error=1; \
1699         fi; \
1700         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1701             doc/security.rst; do \
1702           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1703             "Documents Ganeti version $$expver"; then \
1704             echo "Incorrect version in $$file, expected $$expver" >&2; \
1705             error=1; \
1706           fi; \
1707         done; \
1708         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1709           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1710           error=1; \
1711         fi; \
1712         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1713           ".. Last updated for Ganeti $$expver"; then \
1714           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1715           error=1; \
1716         fi; \
1717         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1718           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1719             echo "Longest line in $$file is longer than 80 characters" >&2; \
1720             error=1; \
1721           fi; \
1722         done; \
1723         test -z "$$error"
1724
1725 .PHONY: hs-tests
1726 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1727         @rm -f htest.tix
1728         ./test/hs/htest
1729
1730 .PHONY: hs-shell
1731 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1732         @rm -f hpc-htools.tix hpc-mon-collector.tix
1733         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1734
1735 .PHONY: hs-check
1736 hs-check: hs-tests hs-shell
1737
1738 # E111: indentation is not a multiple of four
1739 # E121: continuation line indentation is not a multiple of four
1740 #       (since our indent level is not 4)
1741 # E125: continuation line does not distinguish itself from next logical line
1742 #       (since our indent level is not 4)
1743 # E127: continuation line over-indented for visual indent
1744 #       (since our indent level is not 4)
1745 # note: do NOT add E128 here; it's a valid style error in most cases!
1746 # I've seen real errors, but also some cases were we indent wrongly
1747 # due to line length; try to rework the cases where it is triggered,
1748 # instead of silencing it
1749 # E261: at least two spaces before inline comment
1750 # E501: line too long (80 characters)
1751 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1752
1753 # For excluding pep8 expects filenames only, not whole paths
1754 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1755
1756 LINT_TARGETS = pylint pylint-qa
1757 if HAS_PEP8
1758 LINT_TARGETS += pep8
1759 endif
1760 if HAS_HLINT
1761 LINT_TARGETS += hlint
1762 endif
1763
1764 .PHONY: lint
1765 lint: $(LINT_TARGETS)
1766
1767 .PHONY: pylint
1768 pylint: $(GENERATED_FILES)
1769         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1770         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1771
1772 .PHONY: pylint-qa
1773 pylint-qa: $(GENERATED_FILES)
1774         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1775         cd $(top_srcdir)/qa && \
1776           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1777           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1778
1779 .PHONY: pep8
1780 pep8: $(GENERATED_FILES)
1781         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1782         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1783           --repeat $(pep8_python_code)
1784
1785 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1786 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1787 .PHONY: hlint
1788 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1789         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1790         @rm -f doc/hs-lint.html
1791         if tty -s; then C="-c"; else C=""; fi; \
1792         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1793           --ignore "Use first" \
1794           --ignore "Use &&&" \
1795           --ignore "Use void" \
1796           --ignore "Reduce duplication" \
1797           --hint src/lint-hints \
1798           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1799         @if [ ! -f doc/hs-lint.html ]; then \
1800           echo "All good" > doc/hs-lint.html; \
1801         fi
1802
1803 # a dist hook rule for updating the vcs-version file; this is
1804 # hardcoded due to where it needs to build the file...
1805 dist-hook:
1806         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1807         rm -f $(top_distdir)/vcs-version
1808         cp -p $(srcdir)/vcs-version $(top_distdir)
1809
1810 # a distcheck hook rule for catching revision control directories
1811 distcheck-hook:
1812         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1813           echo "Found revision control files in final archive." 1>&2; \
1814           exit 1; \
1815         fi
1816         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1817           echo "Found Python byte code in final archive." 1>&2; \
1818           exit 1; \
1819         fi
1820         if find $(top_distdir) -name '*~' | grep .; then \
1821           echo "Found backup files in final archive." 1>&2; \
1822           exit 1; \
1823         fi
1824 # Empty files or directories should not be distributed. They can cause
1825 # unnecessary warnings for packagers. Directories used by automake during
1826 # distcheck must be excluded.
1827         if find $(top_distdir) -empty -and -not \( \
1828             -path $(top_distdir)/_build -or \
1829             -path $(top_distdir)/_inst \) | grep .; then \
1830           echo "Found empty files or directories in final archive." 1>&2; \
1831           exit 1; \
1832         fi
1833         if test -n "$(BUILD_RELEASE)" && \
1834            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1835            echo "Found unreleased version in NEWS." >&2; \
1836            exit 1; \
1837         fi
1838         if test -e $(top_distdir)/doc/man-html; then \
1839           echo "Found documentation including man pages in final archive" >&2; \
1840           exit 1; \
1841         fi
1842
1843 # When building a release, stricter checks should be used
1844 distcheck-release dist-release: export BUILD_RELEASE = 1
1845 distcheck-release: distcheck
1846
1847 distrebuildcheck: dist
1848         set -e; \
1849         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1850         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1851         cd $$builddir; \
1852         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1853         cd $(distdir); \
1854         ./configure; \
1855         $(MAKE) maintainer-clean; \
1856         cp $(abs_srcdir)/vcs-version .; \
1857         ./configure; \
1858         $(MAKE) $(AM_MAKEFLAGS)
1859
1860 dist-release: dist
1861         set -e; \
1862         for i in $(DIST_ARCHIVES); do \
1863           echo -n "Checking $$i ... "; \
1864           autotools/check-tar < $$i; \
1865           echo OK; \
1866         done
1867
1868 install-exec-local:
1869         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1870           "$(DESTDIR)${localstatedir}/log/ganeti" \
1871           "$(DESTDIR)${localstatedir}/run/ganeti"
1872
1873 .PHONY: apidoc
1874 if WANT_HSAPIDOC
1875 apidoc: py-apidoc hs-apidoc
1876 else
1877 apidoc: py-apidoc
1878 endif
1879
1880 .PHONY: py-apidoc
1881 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1882         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1883         $(RUN_IN_TEMPDIR) epydoc -v \
1884           --conf $(CURDIR)/epydoc.conf \
1885           --output $(CURDIR)/$(APIDOC_PY_DIR)
1886
1887 .PHONY: hs-apidoc
1888 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1889
1890 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1891         @test -n "$(HSCOLOUR)" || \
1892             { echo 'HsColour' not found during configure; exit 1; }
1893         @test -n "$(HADDOCK)" || \
1894             { echo 'haddock' not found during configure; exit 1; }
1895         rm -rf $(APIDOC_HS_DIR)/*
1896         for i in $(ALL_APIDOC_HS_DIRS); do \
1897           @mkdir_p@ $$i; \
1898           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1899         done
1900         set -e ; \
1901         export LC_ALL=en_US.UTF-8; \
1902         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1903         if [ "$(HS_PARALLEL3)" ]; \
1904         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1905         fi; \
1906         if [ "$(HS_REGEX_PCRE)" ]; \
1907         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1908         fi; \
1909         for file in $(HS_LIBTESTBUILT_SRCS); do \
1910           f_nosrc=$${file##src/}; \
1911           f_notst=$${f_nosrc##test/hs/}; \
1912           f_html=$${f_notst%%.hs}.html; \
1913           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1914         done ; \
1915         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1916           -t ganeti -p src/haddock-prologue \
1917           --source-module="%{MODULE/.//}.html" \
1918           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1919           $$OPTGHC \
1920           $(HS_LIBTESTBUILT_SRCS)
1921
1922 .PHONY: TAGS
1923 TAGS: $(GENERATED_FILES)
1924         rm -f TAGS
1925         $(GHC) -e ":etags" -v0 \
1926           $(filter-out -O -Werror,$(HFLAGS)) \
1927           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1928           $(HS_LIBTEST_SRCS)
1929         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1930           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1931           -path './qa/*.py' | \
1932           etags -l python -a -
1933
1934 .PHONY: coverage
1935 if WANT_HTOOLS
1936 coverage: py-coverage hs-coverage
1937 else
1938 coverage: py-coverage
1939 endif
1940
1941 .PHONY: py-coverage
1942 py-coverage: $(GENERATED_FILES) $(python_tests)
1943         @test -n "$(PYCOVERAGE)" || \
1944             { echo 'python-coverage' not found during configure; exit 1; }
1945         set -e; \
1946         COVERAGE=$(PYCOVERAGE) \
1947         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1948         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1949         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1950         $(PLAIN_TESTS_ENVIRONMENT) \
1951         $(abs_top_srcdir)/autotools/gen-py-coverage \
1952         $(python_tests)
1953
1954 .PHONY: hs-coverage
1955 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1956         rm -f *.tix
1957         $(MAKE) $(AM_MAKEFLAGS) hs-check
1958         @mkdir_p@ $(COVERAGE_HS_DIR)
1959         hpc sum --union $(HPCEXCL) \
1960           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1961         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1962         hpc report coverage-hs.tix
1963         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1964
1965 # Special "kind-of-QA" target for htools, needs special setup (all
1966 # tools compiled with -fhpc)
1967 .PHONY: live-test
1968 live-test: all
1969         set -e ; \
1970         cd src; \
1971         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1972         rm -f *.tix *.mix; \
1973         ./live-test.sh; \
1974         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1975           --output=live-test.tix ; \
1976         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1977         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1978           --srcdir=.. $(HPCEXCL) ; \
1979         hpc report --srcdir=.. live-test $(HPCEXCL)
1980
1981 commit-check: distcheck lint apidoc
1982
1983 .PHONY: gitignore-check
1984 gitignore-check:
1985         @if [ -n "`git status --short`" ]; then \
1986           echo "Git status is not clean!" 1>&2 ; \
1987           git status --short; \
1988           exit 1; \
1989         fi
1990
1991 # target to rebuild all man pages (both groff and html output)
1992 .PHONY: man
1993 man: $(man_MANS) $(manhtml)
1994
1995 # Target that builds all binaries (including those that are not
1996 # rebuilt except when running the tests)
1997 .PHONY: really-all
1998 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1999
2000 # we don't need the ancient implicit rules:
2001 %: %,v
2002 %: RCS/%,v
2003 %: RCS/%
2004 %: s.%
2005 %: SCCS/s.%
2006
2007 -include ./Makefile.local
2008
2009 # vim: set noet :